SAL_MapUtil = {};


SetMapToCurrentZone();

local measureStartPoint = nil;
local measureStartTime = nil;
local measureStartHeading = nil;
local measureStartSpeed = nil;

SAL_MapUtil.measuring = false;


if (SAL_mapSizes == nil) then
	SAL_mapSizes = {};
	SAL_mapSizes["AhnQirajTheFallenKingdom"] = {width=4050, height=2700};
	SAL_mapSizes["Arathi"] = {width=3478,height=2319};
	SAL_mapSizes["Ashenvale"] = {width=5770,height=3846};
	SAL_mapSizes["Aszhara"] = {width=5525,height=3684};
	SAL_mapSizes["Azeroth"] = {width=40743,height=27151};
	SAL_mapSizes["Badlands"] = {width=3071,height=2046};
	SAL_mapSizes["Barrens"] = {width=5749,height=3833};
	SAL_mapSizes["BladesEdgeMountains"] = {width=5435,height=3623};
	SAL_mapSizes["BlastedLands"] = {width=3664,height=2442};
	SAL_mapSizes["BoreanTundra"] = {width=5783,height=3856};
	SAL_mapSizes["BurningSteppes"] = {width=3153,height=2100};
	SAL_mapSizes["CrystalsongForest"] = {width=2726,height=1816};
	SAL_mapSizes["Dalaran"] = {width=832,height=554};
	SAL_mapSizes["Darkshore"] = {width=6465,height=4310};
	SAL_mapSizes["Darnassus"] = {width=1540,height=1027};
	SAL_mapSizes["DeadwindPass"] = {width=2502,height=1668};
	SAL_mapSizes["Deepholm"] = {width=5107,height=3405};
	SAL_mapSizes["Desolace"] = {width=4497,height=2999};
	SAL_mapSizes["Dragonblight"] = {width=5609,height=3740};
	SAL_mapSizes["Durotar"] = {width=5288,height=3525};
	SAL_mapSizes["Duskwood"] = {width=2701,height=1801};
	SAL_mapSizes["Dustwallow"] = {width=5247,height=3498};
	SAL_mapSizes["EasternPlaguelands"] = {width=4044,height=2696};
	SAL_mapSizes["Elwynn"] = {width=3471,height=2315};
	SAL_mapSizes["EversongWoods"] = {width=4922,height=3282};
	SAL_mapSizes["Expansion01"] = {width=17475,height=11650};
	SAL_mapSizes["Felwood"] = {width=6096,height=4064};
	SAL_mapSizes["Feralas"] = {width=6953,height=4636};
	SAL_mapSizes["Ghostlands"] = {width=3300,height=2200};
	SAL_mapSizes["GilneasCity"] = {width=897,height=606};
	SAL_mapSizes["GrizzlyHills"] = {width=5250,height=3500};
	SAL_mapSizes["Hellfire"] = {width=5165,height=3444};
	SAL_mapSizes["HillsbradFoothills"] = {width=4867,height=3245};
	SAL_mapSizes["Hinterlands"] = {width=3852,height=2568};
	SAL_mapSizes["HowlingFjord"] = {width=6049,height=4034};
	SAL_mapSizes["Hyjal"] = {width=4256,height=2838};
	SAL_mapSizes["IcecrownGlacier"] = {width=6282,height=4189};
	SAL_mapSizes["LakeWintergrasp"] = {width=2978,height=1985};
	SAL_mapSizes["LochModan"] = {width=2760,height=1841};
	SAL_mapSizes["Moonglade"] = {width=2308,height=1540};
	SAL_mapSizes["Mulgore"] = {width=5454,height=3636};
	SAL_mapSizes["Nagrand"] = {width=5525,height=3683};
	SAL_mapSizes["Netherstorm"] = {width=5589,height=3726};
	SAL_mapSizes["Orgrimmar"] = {width=1746,height=1164};
	SAL_mapSizes["Redridge"] = {width=2570,height=1713};
	SAL_mapSizes["RuinsofGilneas"] = {width=3147,height=2099};
	SAL_mapSizes["SearingGorge"] = {width=2231,height=1488};
	SAL_mapSizes["ShadowmoonValley"] = {width=5529,height=3686};
	SAL_mapSizes["ShattrathCity"] = {width=1306,height=871};
	SAL_mapSizes["SholazarBasin"] = {width=4361,height=2907};
	SAL_mapSizes["Silithus"] = {width=4060,height=2708};
	SAL_mapSizes["SilvermoonCity"] = {width=1211,height=807};
	SAL_mapSizes["Silverpine"] = {width=4200,height=2800};
	SAL_mapSizes["SouthernBarrens"] = {width=7416,height=4944};
	SAL_mapSizes["StonetalonMountains"] = {width=5901,height=3934};
	SAL_mapSizes["StormwindCity"] = {width=1738,height=1158};
	SAL_mapSizes["StranglethornJungle"] = {width=4101,height=2734};
	SAL_mapSizes["SwampOfSorrows"] = {width=2509,height=1673};
	SAL_mapSizes["Tanaris"] = {width=7225,height=4817};
	SAL_mapSizes["Teldrassil"] = {width=5875,height=3917};
	SAL_mapSizes["TerokkarForest"] = {width=5400,height=3600};
	SAL_mapSizes["TheCapeOfStranglethorn"] = {width=3948,height=2633};
	SAL_mapSizes["TheStockade"] = {width=378,height=252};
	SAL_mapSizes["TheStormPeaks"] = {width=7117,height=4745};
	SAL_mapSizes["ThousandNeedles"] = {width=4398,height=2932};
	SAL_mapSizes["Tirisfal"] = {width=4908,height=3272};
	SAL_mapSizes["TwilightHighlands"] = {width=5273,height=3516};
	SAL_mapSizes["Uldum"] = {width=6194,height=4129};
	SAL_mapSizes["UngoroCrater"] = {width=3707,height=2471};
	SAL_mapSizes["Vashjir"] = {width=6946,height=4631};
	SAL_mapSizes["VashjirDepths"] = {width=4075,height=2717};
	SAL_mapSizes["VashjirKelpForest"] = {width=2923,height=1950};
	SAL_mapSizes["VashjirRuins"] = {width=4848,height=3232};
	SAL_mapSizes["WesternPlaguelands"] = {width=4306,height=2870};
	SAL_mapSizes["Wetlands"] = {width=4141,height=2760};
	SAL_mapSizes["Winterspring"] = {width=6148,height=4099};
	SAL_mapSizes["Zangarmarsh"] = {width=5026,height=3351};
	SAL_mapSizes["ZulDrak"] = {width=5000,height=3333};	
end

function SAL_FixMapName(mapName)
	local i=strfind(mapName, "_");
	if (i == nil) then
		return mapName;
	else
		return strsub(mapName, 1,i-1);
	end
end

function SAL_MapUtil.translateCoords(coord, mapName)
	if (mapName == nil) then
		mapName = GetMapInfo();
	end
	mapName = SAL_FixMapName(mapName);
	local mapSize = SAL_mapSizes[mapName];
	if mapSize == nil then 
		-- Use a fake map size
		return {x = coord[1] * 4000, y = coord[2] * 3000 };
--		return {x=0,y=0};
	else
		return {x = coord[1] * mapSize.width, y = coord[2] * mapSize.height };
	end
end

function SAL_MapUtil.hasCurrentMap()
	local mapSize = SAL_mapSizes[SAL_FixMapName(GetMapInfo())];
	return mapSize ~= nil;
end

function SAL_MapUtil.meausreTick()
	if SAL_MapUtil.measuring then
		local measureTime = GetTime();
		local measurePoint = {GetPlayerMapPosition("player")};
		local measureHeading = deg(GetPlayerFacing());
		local measureSpeed = GetUnitSpeed("player");

		if measureStartPoint == nil and measureSpeed ~= 0 then
			measureStartPoint = measurePoint;
			measureStartTime = measureTime;
			measureStartHeading = measureHeading;
			measureStartSpeed = measureSpeed;
		end
		
		-- Not same speed and heading as start, reset
		if measureHeading ~= measureStartHeading or
			measureSpeed ~= measureStartSpeed then
			measureStartPoint = nil;
		end
		
		if measureStartPoint ~= nil and measureTime >= measureStartTime + 2 then
			SAL_MapUtil.measuring = false;
			local xd = measureStartPoint[1] - measurePoint[1];
			local yd = measureStartPoint[2] - measurePoint[2];
			local t = measureTime - measureStartTime;
			local distance = measureSpeed * t;
			local xd_ = distance * cos(measureHeading - 90);
			local yd_ = -distance * sin(measureHeading - 90);
			--print(format("speed %f, heading: %f", measureSpeed, measureHeading));
			--print(format("traveled %f yards (%f x %f) in %f seconds", distance, xd_, yd_, t));
			--print(format("points traveled %f (%f x %f)", sqrt(xd * xd + yd * yd), xd, yd ));
			--print(format("ppm/s %f ", sqrt(xd * xd + yd * yd) * 1000 / t));

			local mapHeight = yd_ / yd;
			local mapWidth = xd_ / xd;
			local mapName = SAL_FixMapName(GetMapInfo());
			SAL_mapSizes[mapName] = { width=mapWidth, height=mapHeight };
			print(format("Measuring complete, map size for %s is: %f x %f", mapName, mapWidth, mapHeight));
		end
	end
end
