-- Update border of digsites
function SAL_UpdateDigSiteBlobs()
	if (SAL_Options.ShowBorders) then
		SAL_DigSites:Show();
		SAL_DigSites:DrawNone();

		local oWidth = 1002;
		local oHeight = 668;
		local scale = 22;
		SAL_DigSites:SetWidth(oWidth * scale);
		SAL_DigSites:SetHeight(oHeight * scale);

		local x, y = GetPlayerMapPosition("player");
		x = x - 0.5;
		y = y - 0.5;
		x = -x * SAL_DigSites:GetWidth();
		y = y * SAL_DigSites:GetHeight();
		SAL_DigSites:SetPoint("CENTER", SalFrame, "CENTER", x, y);

		local numEntries = ArchaeologyMapUpdateAll();
		for i = 1, numEntries do
			local blobID = ArcheologyGetVisibleBlobID(i);
			SAL_DigSites:DrawBlob(blobID, true);
		end
	else
		SAL_DigSites:DrawNone();
		SAL_DigSites:Hide();	
	end
end

